#!/bin/sh
#
# investigate the name of the kernel
#

if [ "x$1" = "x" ]
    then
    kernel=`/bin/ls /lib/modules/*/build/kernel |
    cut -d/ -f4 |
    sort -u |
    tail -1`
else
    kernvers=$1
fi

if [ -z "$kernel" ]; then echo "unable to determine kernel version" >&2; exit 1; fi

# strip "kernel-" off of the front
if expr "$kernel" : "kernel-" >&/dev/null
then
    kernel=`expr "$kernel" : 'kernel-\(.*\)'`
fi

# strip kernel config mnemonic off of the tail
case "$kernel" in
    *smp)
	kernel=`expr "$kernel" : '\(.*\)smp'`
	;;
    *bigmem)
	kernel=`expr "$kernel" : '\(.*\)bigmem'`
	;;
    *enterprise)
	kernel=`expr "$kernel" : '\(.*\)enterprise'`
	;;
esac

echo $kernel
exit 0
