%define afsvers 1.4.11
%define pkgrel 5.cern

# Determine presence of rpmbuild command line --define arguments used for
# option specification
# These include:
# (*) Specify kernel version to build modules against:
#       --define "kernel 2.4.20-1.1931.2.231.2.11.ent"
# (*) Request building of userspace tools
#       --define "build_userspace 1"
# (*) Request building of kernel modules
#       --define "build_modules 1"

%{?kernel: %define _kernel %{kernel}}
%{!?_kernel: %define _kernel %(/bin/bash -c 'x=`uname -r`; echo ${x%%smp}')}

#define kernvers_on_cmdline %{?kernel:1}%{!?kernel:0}
%define build_userspace_on_cmdline %{?build_userspace:1}%{!?build_userspace:0}
%define build_modules_on_cmdline %{?build_modules:1}%{!?build_modules:0}

%{!?no_kdump: %define no_kdump %(/bin/bash -c 'if [[ %_kernel = 2.4* ]]; then echo 0; else echo 1; fi')}

%define need_redhat_buildsys %(/bin/bash -c 'if [[ %_kernel = 2.4* ]]; then echo 1; else echo 0; fi')

%define is_el3 %(/bin/bash -c 'case "`cat /etc/redhat-release`" in (*"release 3"*) echo 1;; (*) echo 0;;esac')
%define is_el4 %(/bin/bash -c 'case "`cat /etc/redhat-release`" in (*"release 4"*) echo 1;; (*) echo 0;;esac')
%define is_el5 %(/bin/bash -c 'case "`cat /etc/redhat-release`" in (*"release 5"*) echo 1;; (*) echo 0;;esac')


# Determine the version of the kernel to build against
# - automatically select the latest kernel with sources from /lib/modules
# - note that this can be overridden on the command line
#
#if !%{kernvers_on_cmdline}
#define kernel %(%{_sourcedir}/openafs-kernel-version.sh)
#endif

# This is where to look for kernel build include files.
#
%define kbase /lib/modules
%define kxmoddir %{kbase}/%{_kernel}
%define ksrcdir %{kxmoddir}/build
%define kobj %(/bin/bash -c 'x=`head -1 -q %{kxmoddir}*/modules.dep`; xx=${x%%:*}; echo .${xx##*.}')

# Set 'debugspec' to 1 if you want to debug the spec file.  This will
# not remove the installed tree as part of the %clean operation
%define debugspec 0

# Set 'enterprisekernelsupport' to 1 if you want to build the
# kernel module for the enterprise kernel
# Note: This will only work for kernvers == 24 on i686
%define enterprisekernelsupport 0

# Set 'bigmemkernelsupport' to 1 if you want to build the
# kernel module for the bigmem kernel
# Note: This will only work for kernvers == 24 on i686
%define bigmemkernelsupport 0
# Set 'krb5support' to 1 if you want to build the openafs-krb5 package
# to distribute aklog and asetkey
%define krb5support 1

# Set 'bootkernelsupport' to 1 if you want to build the
# kernel module for RedHat BOOT Kernels on x86.
%define bootkernelsupport 0

# OpenAFS configuration options
%define enable_bitmap_later 0
%define enable_bos_restricted_mode 0
%define enable_fast_restart 0

# AFSModname Symbol information 
# Mandrake users can define symtab to be "-S iget4_locked -x"
%define symtab -x

# Define the location of your init.d directory
%define initdir /etc/init.d

# Set 'requires_pam_devel' to 0 if compiling for earlier than rh6.2
# (Newer versions of Red Hat require pam-devel in order to build)
%define requires_pam_devel 1

# Define the location of the PAM security module directory
%define pamdir /%{_lib}/security

# Define set of kernel module variations to be built

%{!?mod_up: %define mod_up %(/bin/bash -c 'if [[ -d /lib/modules/%{_kernel}/build ]] ; then echo 1; else echo 0; fi')}
%{!?mod_smp: %define mod_smp %(/bin/bash -c 'if [[ -d /lib/modules/%{_kernel}smp/build ]] ; then echo 1; else echo 0; fi')}
%{!?mod_bigmem: %define mod_bigmem %(/bin/bash -c 'if [[ -d /lib/modules/%{_kernel}bigmem/build ]] ; then echo 1; else echo 0; fi')}
%{!?mod_hugemem: %define mod_hugemem %(/bin/bash -c 'if [[ -d /lib/modules/%{_kernel}hugemem/build ]] ; then echo 1; else echo 0; fi')}
%{!?mod_largesmp: %define mod_largesmp %(/bin/bash -c 'if [[ -d /lib/modules/%{_kernel}largesmp/build ]]; then echo 1; else echo 0; fi')}
%{!?mod_xenU: %define mod_xenU %(/bin/bash -c 'if [[ -d /lib/modules/%{_kernel}xenU/build ]]; then echo 1; else echo 0; fi')}
%{!?mod_xen: %define mod_xen %(/bin/bash -c 'if [[ -d /lib/modules/%{_kernel}xen/build ]]; then echo 1; else echo 0; fi')}
%{!?mod_PAE: %define mod_PAE %(/bin/bash -c 'if [[ -d /lib/modules/%{_kernel}PAE/build ]]; then echo 1; else echo 0; fi')}
%{!?mod_debug: %define mod_debug %(/bin/bash -c 'if [[ -d /lib/modules/%{_kernel}debug/build ]]; then echo 1; else echo 0; fi')}

%define kvar_up ""
%define kvar_smp ""
%define kvar_hugemem ""
%define kvar_largesmp ""
%define kvar_xen ""
%define kvar_xenU ""
%define kvar_PAE ""
%define kvar_debug ""

%if !%{is_el5}

%ifarch i686
%define mod_up 1
%define mod_smp 1
%endif

%ifarch athlon
%define mod_up 1
%define mod_smp 1
%endif

%ifarch i586
%define mod_up 1
%endif

%ifarch i386
%define mod_up 1
%define mod_smp 1
%endif

%ifarch ia64
# we cheat here, up is REALLY smp with up naming ....
%if %{is_el3}
%define kvariations up 
%else
%define mod_largesmp 1
%endif
%define mod_up 1
%endif

#...!is_el5
%else

# we'll get for what kernel to build from modules lines above...

# SLC5/RHEL5
#define mod_up 1
#define mod_smp 0
#define mod_xen 1
#mod_debug: FATAL: modpost: GPL-incompatible module libafs.ko uses GPL-only symbol 'mutex_lock_nested'
%define mod_debug 0
%ifarch i686
#define mod_PAE 1
%endif

#...is_el5
%endif

%if %{mod_up}
%define kvar_up up
%endif
%if %{mod_smp}
%define kvar_smp smp
%endif
%if %{mod_largesmp}
%define kvar_largesmp largesmp
%endif
%if %{mod_hugemem}
%define kvar_hugemem hugemem
%endif
%if %{mod_xenU}
%define kvar_xenU xenU
%endif
%if %{mod_xen}
%define kvar_xen xen
%endif
%if %{mod_PAE}
%define kvar_PAE PAE
%endif
%if %{mod_debug}
%define kvar_debug debug
%endif

%define kvariations %(echo %{kvar_up} %{kvar_smp} %{kvar_hugemem} %{kvar_xenU} %{kvar_largesmp} %{kvar_xen} %{kvar_PAE} %{kvar_debug})


# Determine which elements of OpenAFS to build.  For non-x86 arches
# (subject to the ExclusiveArch setting, below), we build both userspace
# and modules.  For most x86 arches, we build just the kernel modules.  For
# i386, we build just the userspace.  If you're running an i386 kernel,
# you'll need to tweak that last bit.
%if !%{build_userspace_on_cmdline} && !%{build_modules_on_cmdline}
%ifarch x86_64 ia64
%define build_userspace 1
%define build_modules 1
%endif
%ifarch %{ix86}
%define build_userspace 0
%define build_modules 1
%endif
%ifarch i386
%define build_userspace 1
%define build_modules 0
%endif

%endif

# deal with cmdline specification
%if %{build_userspace_on_cmdline} || %{build_modules_on_cmdline}
%if !%{build_userspace_on_cmdline}
%define build_userspace 0
%endif
%if !%{build_modules_on_cmdline}
%define build_modules 0
%endif
%endif

#######################################################################
# You probably don't need to change anything beyond this line
# NOTE: If you do, please email me!!!

# Make sure RPM doesn't complain about installed but non-packaged files.
%define __check_files  %{nil}

# Don't strip files - rpm magic ?!?!?
%define __spec_install_post %{nil}

# don't produce a debug package
%define debug_package %{nil}

Summary: OpenAFS distributed filesystem
Name: openafs
Version: %{afsvers}
Release: %{pkgrel}
Epoch: 1
License: IBM Public License
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Packager: Rainer Toebbicke <Rainer.Toebbicke@cern.ch>
Vendor: Scientific Linux
Group: Networking/Filesystems
#BuildRequires: kernel-source, autoconf
BuildRequires: /usr/bin/flex, /usr/bin/yacc, ncurses-devel

%if %{is_el3}
BuildRequires: kernel-source
%endif

%if %{is_el4} || %{is_el5}
%if %{mod_up}
BuildRequires: kernel-devel
%endif
%if %{mod_smp}
BuildRequires: kernel-smp-devel
%endif
%if %{mod_largesmp}
BuildRequires: kernel-largesmp-devel
%endif
%if %{mod_hugemem}
BuildRequires: kernel-hugemem-devel
%endif
%if %{mod_xenU}
BuildRequires: kernel-xenU-devel
%endif
%if %{mod_xen}
BuildRequires: kernel-xen-devel
%endif
%if %{mod_PAE}
BuildRequires: kernel-PAE-devel
%endif
%if %{mod_debug}
BuildRequires: kernel-debug-devel
%endif
%endif

ExclusiveArch: %{ix86} x86_64 ia64

%if %{requires_pam_devel}
BuildRequires: pam-devel
%else
BuildRequires: %{_includedir}/security/pam_modules.h
%endif

%ifarch i386
Requires: /sbin/insmod
%endif

Source0: http://www.openafs.org/dl/openafs/${afsvers}/openafs-%{afsvers}-src.tar.bz2
#Source1: http://www.openafs.org/dl/openafs/${afsvers}/openafs-doc.tar.bz2
Source2: openafs-ThisCell
# http://grand.central.org/dl/cellservdb/CellServDB
Source3: openafs-CellServDB
Source4: openafs-SuidCells
Source5: openafs-cacheinfo
Source6: openafs-afsmodname
Source7: openafs-LICENSE.Sun
Source8: openafs-README
# Source10: http://www.openafs.org/dl/openafs/${afsvers}/RELNOTES-%{afsvers}
#Source11: http://www.openafs.org/dl/openafs/${afsvers}/ChangeLog


Source21: openafs-kernel-version.sh
Source30: http://www.tu-chemnitz.de/urz/afs/openafs/download/suse-7.2/SOURCES/openafs-killafs

%define xxkrb5support 0
%if %{xxkrb5support}
Source20: openafs-krb5-2.0.tar.gz
Patch10: afs-krb5-2.0-krb524.patch
Patch11: afs-krb5-2.0-libsocket.patch
Patch12: afs-krb5-2.0-com_err.patch
Patch13: afs-krb5-2.0-openafs1.3.patch
Patch14: afs-krb5-2.0-res_search.patch
Patch42: afs-krb5-2.0-lib64.patch
Patch43: afs-krb5-2.0-64bit.patch
%endif



%description
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides common files shared across all the various
OpenAFS packages but are not necessarily tied to a client or server.

###############################################################################
#
# build the userspace side of things if so requested
#
###############################################################################
%if %{build_userspace}

%package client
Requires: binutils, openafs-kernel, openafs = %{epoch}:%{version}-%{release}
Summary: OpenAFS Filesystem Client
Group: Networking/Filesystem

%description client
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides basic client support to mount and manipulate
AFS.

%package server
Requires: openafs-kernel, openafs = %{epoch}:%{version}-%{release}
Summary: OpenAFS Filesystem Server
Group: Networking/Filesystems

%description server
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides basic server support to host files in an AFS
Cell.

%package devel
Summary: OpenAFS Development Libraries and Headers
Group: Development/Filesystems

%description devel
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides static development libraries and headers needed
to compile AFS applications.  Note: AFS currently does not provide
shared libraries.

%endif

###############################################################################
#
# build the kernel modules if so requested
#
###############################################################################
%if %{build_modules}

#define kernel %{kernvers}
#define modkversion %(echo %{kernvers} | cut -d- -f1)
#define modkrelease %(echo %{kernvers} | cut -d- -f2)
#define modpkgrel %{modkversion}_%{modkrelease}.%{pkgrel}

%if %{mod_up}

%package -n kernel-module-openafs-%{_kernel}
Summary: OpenAFS Kernel Module (compiled for UP)
Requires: openafs >= %{epoch}:%{version}-%{release}
%ifarch ia64
Requires: /boot/efi/EFI/redhat/vmlinuz-%{_kernel}, modutils
%else
Requires: /boot/vmlinuz-%{_kernel}, modutils
%endif
Provides: openafs-kernel, kernel-module-openafs = %{epoch}:%{version}-%{release}
Provides: kernel-module
Group: Networking/Filesystems

%description -n kernel-module-openafs-%{_kernel}
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides an openafs kernel module for
kernel %{_kernel} and architecture %{_target_cpu}.

%endif

%if %{mod_smp}

%package -n kernel-module-openafs-%{_kernel}smp
Summary: OpenAFS Kernel Module (compiled for SMP)
Requires: openafs >= %{epoch}:%{version}-%{release}
Requires: /boot/vmlinuz-%{_kernel}smp, modutils
Provides: openafs-kernel, kernel-module-openafs = %{epoch}:%{version}-%{release}
Provides: kernel-module
Group: Networking/Filesystems

%description -n kernel-module-openafs-%{_kernel}smp
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides an openafs kernel module for
kernel %{_kernel}smp and architecture %{_target_cpu}.

%endif

%if %{mod_bigmem}

%package -n kernel-module-openafs-%{_kernel}bigmem
Summary: OpenAFS Kernel Module (compiled for SMP & big memory support)
Requires: openafs >= %{epoch}:%{version}-%{release}
Obsoletes: openafs-kernel
Requires: /boot/vmlinuz-%{_kernel}bigmem, modutils
Provides: openafs-kernel, kernel-module-openafs = %{epoch}:%{version}-%{release}
Provides: kernel-module
Group: Networking/Filesystems

%description -n kernel-module-openafs-%{_kernel}bigmem
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides an openafs kernel module for
kernel %{_kernel}bigmem and architecture %{_target_cpu}.

%endif

%if %{mod_hugemem}

%package -n kernel-module-openafs-%{_kernel}hugemem
Summary: OpenAFS Kernel Module (compiled for SMP & huge memory support)
Requires: openafs >= %{epoch}:%{version}-%{release}
Obsoletes: openafs-kernel
Requires: /boot/vmlinuz-%{_kernel}hugemem, modutils
Provides: openafs-kernel, kernel-module-openafs = %{epoch}:%{version}-%{release}
Provides: kernel-module
Group: Networking/Filesystems

%description -n kernel-module-openafs-%{_kernel}hugemem
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides an openafs kernel module for
kernel %{_kernel}hugemem and architecture %{_target_cpu}.

%endif

%if %{mod_largesmp}

%package -n kernel-module-openafs-%{_kernel}largesmp
Summary: OpenAFS Kernel Module (compiled for Large SMP memory support)
Requires: openafs >= %{epoch}:%{version}-%{release}
%ifarch ia64
Requires: /boot/efi/EFI/redhat/vmlinuz-%{_kernel}largesmp, modutils
%else
Requires: /boot/vmlinuz-%{_kernel}largesmp, modutils
%endif
Provides: openafs-kernel, kernel-module-openafs = %{epoch}:%{version}-%{release}
Provides: kernel-module
Group: Networking/Filesystems

%description -n kernel-module-openafs-%{_kernel}largesmp
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides an openafs kernel module for
kernel %{_kernel}largesmp and architecture %{_target_cpu}.

%endif

%if %{mod_xenU}

%package -n kernel-module-openafs-%{_kernel}xenU
Summary: OpenAFS Kernel Module (compiled for Xen Domain U support)
Requires: openafs >= %{epoch}:%{version}-%{release}
Requires: /boot/vmlinuz-%{_kernel}xenU, modutils
Provides: openafs-kernel, kernel-module-openafs = %{epoch}:%{version}-%{release}
Provides: kernel-module
Group: Networking/Filesystems

%description -n kernel-module-openafs-%{_kernel}xenU
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides an openafs kernel module for
kernel %{_kernel}xenU and architecture %{_target_cpu}.

%endif

%if %{mod_xen}

%package -n kernel-module-openafs-%{_kernel}xen
Summary: OpenAFS Kernel Module (compiled for Xen Domain 0 support)
Requires: openafs >= %{epoch}:%{version}-%{release}
%ifarch ia64
Requires: /boot/efi/EFI/redhat/vmlinuz-%{_kernel}xen, modutils
%else
Requires: /boot/vmlinuz-%{_kernel}xen, modutils
%endif
Provides: openafs-kernel, kernel-module-openafs = %{epoch}:%{version}-%{release}
Provides: kernel-module
Group: Networking/Filesystems

%description -n kernel-module-openafs-%{_kernel}xen
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides an openafs kernel module for
kernel %{_kernel}xen and architecture %{_target_cpu}.

%endif

%if %{mod_PAE}

%package -n kernel-module-openafs-%{_kernel}PAE
Summary: OpenAFS Kernel Module (compiled for PAE support)
Requires: openafs >= %{epoch}:%{version}-%{release}
Requires: /boot/vmlinuz-%{_kernel}PAE, modutils
Provides: openafs-kernel, kernel-module-openafs = %{epoch}:%{version}-%{release}
Provides: kernel-module
Group: Networking/Filesystems

%description -n kernel-module-openafs-%{_kernel}PAE
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides an openafs kernel module for
kernel %{_kernel}PAE and architecture %{_target_cpu}.

%endif

%if %{mod_PAE}

%package -n kernel-module-openafs-%{_kernel}debug
Summary: OpenAFS Kernel Module (compiled for debug support)
Requires: openafs >= %{epoch}:%{version}-%{release}
Requires: /boot/vmlinuz-%{_kernel}debug, modutils
Provides: openafs-kernel, kernel-module-openafs = %{epoch}:%{version}-%{release}
Provides: kernel-module
Group: Networking/Filesystems

%description -n kernel-module-openafs-%{_kernel}debug
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides an openafs kernel module for
kernel %{_kernel}debug and architecture %{_target_cpu}.

%endif

%endif
#build modules


%package kernel-source
Summary: OpenAFS Kernel Module source tree
Group: Networking/Filesystems

%description kernel-source
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides the source code to build your own AFS kernel
module.

%package compat
Summary: OpenAFS client compatibility symlinks
Requires: openafs = %{epoch}:%{version}-%{release}, openafs-client = %{epoch}:%{version}-%{release}
Group: Networking/Filesystems
Obsoletes: openafs-client-compat

%description compat
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides compatibility symlinks in /usr/afsws.  It is
completely optional, and is only necessary to support legacy
applications and scripts that hard-code the location of AFS client
programs.

%package kpasswd
Summary: OpenAFS KA kpasswd support
Requires: openafs
Group: Networking/Filesystems

%description kpasswd
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides the compatibility symlink for kpasswd, in case
you are using KAserver instead of Krb5.

%if %{krb5support}
%package krb5
Summary: OpenAFS programs to use with krb5
Requires: openafs = %{epoch}:%{version}-%{release}
Group: Networking/Filesystems
BuildRequires: krb5-devel

%description krb5
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides compatibility programs so you can use krb5
to authenticate to AFS services, instead of using AFS's homegrown
krb4 lookalike services.
%endif

###############################################################################
#
# preparation
#
###############################################################################

%prep

: @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
: @@@
: @@@ kernel version:     %{_kernel}
: @@@ kernel modules dir: %{kxmoddir}
: @@@ kernel modules type:  %{kobj}
: @@@ kernel RPM version: kernel*-%{_kernel}
: @@@ PAM modules dir:      %{pamdir}
: @@@ build userspace:      %{build_userspace}
: @@@ build modules:        %{build_modules}
: @@@ Modules:
: @@@        mod_up: %{mod_up} mod_smp: %{mod_smp} mod_largesmp: %{mod_largesmp}  mod_hugemem %{mod_hugemem}
: @@@        mod_xenU %{mod_xenU} mod_xen %{mod_xen} mod_PAE %{mod_PAE} mod_debug %{mod_debug}
: @@@ kvariations:          %{kvariations}
: @@@ arch:                 %{_arch}
: @@@ target cpu:           %{_target_cpu}
: @@@ no_kdump:		    %{no_kdump}
: @@@ need_redhat_buildsys: %{need_redhat_buildsys}
: @@@
: @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

#%setup -q -b 1 -c -n openafs-%{afsvers}
%setup -q -c -n openafs-%{afsvers}

%if %{xxkrb5support}
%setup -q -T -D -a 20

#
# patch afs-krb5 migration kit to work with openafs-1.3 and krb5-1.3;
# add some features and fix bugs
#

# krb524 is no longer in a separate library as of krb5-1.3; handle this
%patch10 -p0 -b .krb524

# make sure NETLIBS gets added to the proper programs (seems to be 
# needed only for Solaris)
%patch11 -p0 -b .libsocket

# find an existing libcom_err and use that
%patch12 -p0 -b .com_err

# make afs-krb5 work with recent OpenAFS; includes and prototypes
%patch13 -p0 -b .openafs13

# nothing in afs-krb5 actually uses res_search
%patch14 -p0 -b .res_search

# build on x86_64 (in 64-bit mode)
###%patch42 -p0 -b .lib64

# 0 != NULL x86_64 / ia64
%patch43 -p0 -b .64bit

(cd afs-krb5/src && autoreconf) || exit 1
%endif

#%patch100 -p1
%ifarch x86_64
 %if %{xxkrb5support}
#%patch204 -p1
 %endif
%endif
###############################################################################
#
# building
#
###############################################################################

%build

case %{_kernel} in
   2.4.*) kv='24' ;;
   2.6.*) kv='26' ;;
   *)
        echo "I don't know how to build linux-`expr ${_kernel} : \(^[0-9]*[.][0-9]*\)`"
        exit 1
        ;;
esac

case %{_arch} in
        x86_64)                         sysname=amd64_linux${kv}        ;;
        alpha*)                         sysname=alpha_linux_${kv}       ;;
        i386|i486|i586|i686|athlon)     sysname=i386_linux${kv}         ;;
        *)                              sysname=%{_arch}_linux${kv}     ;;
esac

%ifarch x86_64
perl -pi -e 's,^(XCFLAGS.*),\1 -fPIC,' src/config/Makefile.amd64_linux24.in
perl -pi -e 's,^(XLIBS.*),\1 -lresolv,' src/config/Makefile.amd64_linux24.in
%endif

%ifarch %{ix86}
archlist="i386 i586 i686 athlon"
%if %{bootkernelsupport}
  archlist="${archlist} BOOT"
%endif
%else
archlist=%{_arch}
%endif

#
# PrintDefine var value statements file
#
PrintDefine() {
    case $3 in
    *ifn*)
	echo "#ifndef $1" >> $4
	;;
    esac
    case $3 in
    *und*)
	echo "#undef $1" >> $4
	;;
    esac
    case $3 in
    *def*)
	echo "#define $1 $2" >> $4
	;;
    esac
    case $3 in
    *end*)
	echo "#endif" >> $4
	;;
    esac
    case $3 in
    *inc*)
	echo "#include $1" >> $4
	;;
    esac


    case $3 in
    *nl*)
	echo "" >> $4
	;;
    esac
}

# PrintRedhatKernelFix arch mp file
PrintRedhatKernelFix() {
    arch="$1"
    up=0
    smp=0
    ent=0
    bigmem=0
    boot=0
    bootsmp=0
    hugemem=0

    case "$2" in
        up)     up=1;;
        smp)    smp=1;;
        bigmem) bigmem=1;;
        hugemem) hugemem=1;; 
        *)
                echo "$2 not supported"
                exit 2;;
    esac

    file="$3"

    rm -f $file
    touch $file

    PrintDefine "REDHAT_FIX_H" "" ifn,def,nl $file

    PrintDefine __BOOT_KERNEL_ENTERPRISE    $ent      und,def,nl $file
    PrintDefine __BOOT_KERNEL_BIGMEM        $bigmem   und,def,nl $file
    PrintDefine __BOOT_KERNEL_HUGEMEM       $hugemem  und,def,nl $file
    PrintDefine __BOOT_KERNEL_SMP           $smp      und,def,nl $file
    PrintDefine __BOOT_KERNEL_UP            $up       und,def,nl $file
    PrintDefine __BOOT_KERNEL_BOOT          $boot     und,def,nl $file
    PrintDefine __BOOT_KERNEL_BOOTSMP       $bootsmp  und,def,nl $file

    PrintDefine '"/boot/kernel.h"' "" inc,nl $file      # include file

    for ar in $archlist ; do
	if [ "$ar" = "$arch" ]; then
	    PrintDefine "__MODULE_KERNEL_$ar" "1" ifn,def,end $file
	else
	    PrintDefine "__MODULE_KERNEL_$ar" "" und $file	# undef
        fi
    done
    echo "" >> $file

    PrintDefine "" "" end $file

    if [ %{debugspec} = 1 ] ; then
	echo "Kernel Configuration File for Red Hat kernels:"
	cat $file
    fi
}

config_opts=" \
%if %{enable_bitmap_later}
	--enable-bitmap-later \
%endif
%if %{enable_bos_restricted_mode}
	--enable-bos-restricted-mode \
%endif
%if %{enable_fast_restart}
	--enable-fast-restart \
%endif
%if %{need_redhat_buildsys}
        --enable-redhat-buildsys \
%endif
	--enable-transarc-paths"

# Configure AFS

CFLAGS="$RPM_OPT_FLAGS"; export CFLAGS

# On some platforms, static libraries must be built with -fPIC before we can
# link them into shared objects.  Because the PAM module uses the libraries,
# we need to build them with -fPIC.  This is one way to do it.
%ifarch x86_64
CFLAGS="$CFLAGS -fPIC"; export CFLAGS
%endif


./configure --with-afs-sysname=${sysname} \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--bindir=%{_bindir} \
	--sbindir=%{_sbindir} \
%if %{krb5support}
	--with-krb5-conf \
%endif
	$config_opts \
	|| exit 1

%if %{build_userspace}
# Build the user-space AFS stuff
make dest_nolibafs || exit 1
make build TARGET=pam COMPILE_PART2B=dest || exit 1

# Build the libafs tree
make only_libafs_tree || exit 1

%endif

%if %{build_modules}

for variation in %{kvariations}
do

%if %{is_el5}
    mps="MP"
    local_smp_def="-DAFS_SMP -DREDHAT_FIX" 
    suffix=${variation}
    if [ ${variation} = up ]
    then
      suffix=
    fi
%else
    if [ ${variation} = up ]
    then
        mps="SP"
	local_smp_def=-DREDHAT_FIX
        suffix=
%ifarch ia64
	# ALL IA64 kernels are SMP
	mps="MP"
	local_smp_def="-DAFS_SMP -DREDHAT_FIX"
%endif
    else
    	mps="MP"
	local_smp_def="-DAFS_SMP -DREDHAT_FIX"
        suffix=${variation}
    fi
%endif        
    ./configure --with-afs-sysname=${sysname} \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--bindir=%{_bindir} \
	--sbindir=%{_sbindir} \
	--with-linux-kernel-headers=%{kbase}/%{_kernel}${suffix}/build \
%if %{krb5support}
	--with-krb5-conf \
%endif
	$config_opts \
	|| exit 1


%if %{need_redhat_buildsys}
    PrintRedhatKernelFix %{_target_cpu} $variation src/config/redhat-fix.h
    make dest_only_libafs LOCAL_SMP_DEF="${local_smp_def}" LINUX_MODULE_VARIETY="$variation" KMODDIR="%{kxmoddir}${suffix}/kernel/fs/openafs" MPS="$mps"

    rm -f src/config/redhat-fix.h
%else
    rm -f src/libafs/Makefile
    ex - src/libafs/MakefileProto.LINUX <<EOFmfproto
\$
?^LINUX_KERNEL_PATH=? a
LINUX_KERNEL_PATH=%{kxmoddir}${suffix}/build
.
w!
EOFmfproto
    make dest_only_libafs MPS="$mps"
%endif

    kdumpTgt=`pwd`/${sysname}/dest/etc
%if !%{no_kdump}
    make cmd
    cd src/venus
    make $kdumpTgt/kdump
    [ -s $kdumpTgt/kdump-%{_kernel}smp ] || ln $kdumpTgt/kdump-%{_kernel} $kdumpTgt/kdump-%{_kernel}smp
    cd ../..
%else
    touch $kdumpTgt/kdump-%{_kernel}
    touch $kdumpTgt/kdump-%{_kernel}smp
%endif
done

%endif

###############################################################################
#
# installation
#
###############################################################################

%install
export DONT_GPRINTIFY=1
[ $RPM_BUILD_ROOT != / ] && rm -rf $RPM_BUILD_ROOT

case %{_kernel} in
   2.4.*) kv='24' ;;
   2.6.*) kv='26' ;;
   *)
        echo "I don't know how to build linux-`expr ${_kernel} : \(^[0-9]*[.][0-9]*\)`"
        exit 1
        ;;
esac

case %{_arch} in
        x86_64)                         sysname=amd64_linux${kv}        ;;
        alpha*)                         sysname=alpha_linux_${kv}       ;;
        i386|i486|i586|i686|athlon)     sysname=i386_linux${kv}         ;;
        *)                              sysname=%{_arch}_linux${kv}     ;;
esac


# Build install tree
%if %{build_userspace}
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT%{_libdir}
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
mkdir -p $RPM_BUILD_ROOT%{initdir}
mkdir -p $RPM_BUILD_ROOT/etc/openafs
mkdir -p $RPM_BUILD_ROOT%{pamdir}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/afs/logs
mkdir -p $RPM_BUILD_ROOT%{_prefix}/vice/etc
mkdir -p $RPM_BUILD_ROOT%{_prefix}/vice/cache
chmod 700 $RPM_BUILD_ROOT%{_prefix}/vice/cache


# Copy files from dest to the appropriate places in BuildRoot
tar cf - -C ${sysname}/dest bin include | tar xf - -C $RPM_BUILD_ROOT%{_prefix}
tar cf - -C ${sysname}/dest/lib . | tar xf - -C $RPM_BUILD_ROOT%{_libdir}
tar cf - -C ${sysname}/dest/etc . | tar xf - -C $RPM_BUILD_ROOT%{_sbindir}
tar cf - -C ${sysname}/dest/root.server%{_prefix}/afs bin | tar xf - -C $RPM_BUILD_ROOT%{_prefix}/afs
tar cf - -C ${sysname}/dest/root.client%{_prefix}/vice/etc afsd C | tar xf - -C $RPM_BUILD_ROOT%{_prefix}/vice/etc

# Link kpasswd to kapasswd
mv -f $RPM_BUILD_ROOT%{_bindir}/kpasswd $RPM_BUILD_ROOT%{_bindir}/kpasswd.openafs
ln -f $RPM_BUILD_ROOT%{_bindir}/kpasswd.openafs $RPM_BUILD_ROOT%{_bindir}/kapasswd
mv -f $RPM_BUILD_ROOT%{_bindir}/pagsh $RPM_BUILD_ROOT%{_bindir}/pagsh.openafs


# Copy root.client config files
install -m 755 ${sysname}/dest/root.client%{_prefix}/vice/etc/afs.conf $RPM_BUILD_ROOT/etc/sysconfig/afs
install -m 755 ${sysname}/dest/root.client%{_prefix}/vice/etc/afs.rc $RPM_BUILD_ROOT%{initdir}/afs

# Copy PAM modules
install -m 755 ${sysname}/dest/lib/pam* $RPM_BUILD_ROOT%{pamdir}

# PAM symlinks
ln -sf pam_afs.so.1 $RPM_BUILD_ROOT%{pamdir}/pam_afs.so
ln -sf pam_afs.krb.so.1 $RPM_BUILD_ROOT%{pamdir}/pam_afs.krb.so


uve=$RPM_BUILD_ROOT%{_prefix}/vice/etc
install -p -m 644 %{SOURCE2} $uve/ThisCell
install -p -m 644 %{SOURCE3} $uve/CellServDB
install -p -m 644 %{SOURCE4} $uve/SuidCells
install -p -m 644 %{SOURCE5} $uve/cacheinfo
#
install -p -m 755 %{SOURCE30} $uve/killafs

#
# install kernel-source
#

# Install the kernel module source tree
mkdir -p $RPM_BUILD_ROOT%{_prefix}/src/openafs-kernel-%{afsvers}/src
tar cf - -C libafs_tree . | \
        tar xf - -C $RPM_BUILD_ROOT%{_prefix}/src/openafs-kernel-%{afsvers}/src

# Next, copy the LICENSE Files, README
install -m 644 src/LICENSE $RPM_BUILD_ROOT%{_prefix}/src/openafs-kernel-%{afsvers}/LICENSE.IBM
install -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_prefix}/src/openafs-kernel-%{afsvers}/LICENSE.Sun
install -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{_prefix}/src/openafs-kernel-%{afsvers}/README

#
# Install DOCUMENTATION
#

# Build the DOC directory
mkdir -p $RPM_BUILD_ROOT/$RPM_DOC_DIR/openafs-%{afsvers}
tar cf - -C doc LICENSE html pdf | \
    tar xf - -C $RPM_BUILD_ROOT/$RPM_DOC_DIR/openafs-%{afsvers}
#install -m 644 %{SOURCE10} $RPM_BUILD_ROOT/$RPM_DOC_DIR/openafs-%{afsvers}
#install -m 644 %{SOURCE11} $RPM_BUILD_ROOT/$RPM_DOC_DIR/openafs-%{afsvers}

#
# man pages
#
( cd doc/man-pages
  for d in man*; do
      mkdir -p $RPM_BUILD_ROOT%{_mandir}/$d
      for x in $d/*; do
        if [ -f $x ]; then
                install -p -m 644 $x $RPM_BUILD_ROOT%{_mandir}/$d
        fi
      done
  done
) || exit 1

%if !%{krb5support} 
[ -f $RPM_BUILD_ROOT%{_mandir}/man1/aklog.1 ] && rm -f $RPM_BUILD_ROOT%{_mandir}/man1/aklog.1
%endif

# remove unused man pages
for x in afs_ftpd afs_inetd afs_login afs_rcp afs_rlogind afs_rsh \
    dlog dpass dkload kdb knfs package runntp; do
        rm -f $RPM_BUILD_ROOT%{_mandir}/man1/${x}.1
done


# gzip man pages
gzip -9 $RPM_BUILD_ROOT%{_mandir}/man*/*

# rename kpasswd to kapasswd
mv $RPM_BUILD_ROOT%{_mandir}/man1/kpasswd.1.gz $RPM_BUILD_ROOT%{_mandir}/man1/kapasswd.1.gz
ln -f $RPM_BUILD_ROOT%{_mandir}/man1/kapasswd.1.gz $RPM_BUILD_ROOT%{_mandir}/man1/kpasswd.openafs.1.gz
mv $RPM_BUILD_ROOT%{_mandir}/man1/pagsh.1.gz $RPM_BUILD_ROOT%{_mandir}/man1/pagsh.openafs.1.gz

# create list of man pages that go in the 'openafs' package
( cd $RPM_BUILD_ROOT%{_mandir}; /bin/ls man*/* \
        |egrep '/(afs)|(bos[_\.])|(fs)|(pag)|(pts)|(scout)|(tokens)|(unlog)|(vos)'; ) \
        >openafs-manfiles


#
# create filelist
#
grep -v "^#" >openafs-file-list <<EOF-openafs-file-list
%{_bindir}/afsmonitor
%{_bindir}/bos
%{_bindir}/fs
# in openafs-kpasswd
#%{_bindir}/kapasswd
#
#%{_bindir}/kpasswd
%{_bindir}/klog
%{_bindir}/klog.krb
%{_bindir}/pagsh.openafs
%{_bindir}/pagsh.krb
%{_bindir}/pts
%{_bindir}/scout
%{_bindir}/sys
%{_bindir}/tokens
%{_bindir}/tokens.krb
%{_bindir}/translate_et
%{_bindir}/udebug
%{_bindir}/unlog
%{_bindir}/xstat_cm_test
%{_bindir}/xstat_fs_test
%attr(0555,root,root) %{_sbindir}/backup
%attr(0555,root,root) %{_sbindir}/butc
%{_sbindir}/fms
%attr(0555,root,root) %{_sbindir}/fstrace
%{_sbindir}/kas
%{_sbindir}/read_tape
%{_sbindir}/restorevol
%attr(0555,root,root) %{_sbindir}/rxdebug
%{_sbindir}/uss
%attr(0555,root,root) %{_sbindir}/vos
EOF-openafs-file-list


# add man pages to the list
echo "openafs-manfiles:"
cat openafs-manfiles
cat openafs-manfiles \
        | ( while read x; do echo "%{_mandir}/$x"; done ) \
        >>openafs-file-list
#
# Install compatiblity links
#
for d in bin:bin etc:sbin; do
  olddir=`echo $d | sed 's/:.*$//'`
  newdir=`echo $d | sed 's/^.*://'`
  mkdir -p $RPM_BUILD_ROOT%{_prefix}/afsws/$olddir
#  for f in `cat openafs-file-list`; do
  while read attr f; do
    [[ -z "$f" ]] && f=$attr
    if echo $f | grep -q /$newdir/; then
      fb=`basename $f`
      ln -sf %{_prefix}/$newdir/$fb $RPM_BUILD_ROOT%{_prefix}/afsws/$olddir/$fb
    fi
  done < openafs-file-list
done

%endif

%if %{build_modules}
for variation in %{kvariations}
do

# Not necessarily %{_kernel} here:
# configure uses UTS_RELEASE in %{ksrcdir}/include/linux/version.h and takes
# the last (no matter how  wrong) one in case of #ifdefs.
# 
# Now what? guess, use something like config.log or do the same nonsense?
# Try guessing based on what ends up in the modload directory

    srcdir=${sysname}/dest/root.client/usr/vice/etc/modload
    for k in $srcdir/libafs-*o; do
	xx="${k#*libafs-}"	# strip everything up to libafs-
	k="${xx%.*o}"		# trailing .o or .?o
	eval "o=\"\${xx##$k}\""	# what the trailer actually is
	k="${k%*.mp}"		# strip .mp.o
	[[ -n "$k" ]] & break
    done

%if %{is_el5}
    if [ ${variation} = up ]
    then
     kvar=%{kxmoddir} 
     libafs="libafs-%{_kernel}.mp%{kobj}"
    else
     kvar=%{kxmoddir}${variation}
     libafs="libafs-%{_kernel}${variation}.mp%{kobj}"
    fi 
%else	
    if [ ${variation} = up ]
    then
        kvar=%{kxmoddir}
	libafs="libafs-%{_kernel}${o}"
%ifarch ia64
	libafs="libafs-%{_kernel}.mp%{kobj}"
%endif
    else
        kvar=%{kxmoddir}${variation}
	libafs="libafs-%{_kernel}${variation}.mp%{kobj}"
	[[ -s ${srcdir}/${libafs} ]] || {
		xx="%{_kernel}"
		libafs="libafs-${xx%%smp}.mp%{kobj}"
	}
    fi
%endif


###%ifarch ia64
###  dstdir=$RPM_BUILD_ROOT/%{kxmoddir}/kernel/fs/openafs
###%else
    dstdir=$RPM_BUILD_ROOT/${kvar}/kernel/fs/openafs
###%endif

    mkdir -p ${dstdir}

    install -m 644 ${srcdir}/${libafs} ${dstdir}/openafs${o}
done

    mkdir -p $RPM_BUILD_ROOT/usr/sbin
    install -m 644 ${sysname}/dest/etc/* $RPM_BUILD_ROOT/usr/sbin
%endif

%clean
rm -f openafs-file-list
[ "$RPM_BUILD_ROOT" != "/" -a "x%{debugspec}" != "x1" ] && \
	rm -fr $RPM_BUILD_ROOT


###############################################################################
###
### scripts
###
###############################################################################
%if %{build_userspace}

%pre compat
if [ -e /usr/afsws ]; then
        /bin/rm -fr /usr/afsws
fi

%post
# If afs was configured already: don't touch
# if not add to config but disable
/sbin/chkconfig --list afs > /dev/null 2>&1
if [ $? -ne 0 ]; then
 /sbin/chkconfig --add afs
 # Add afs but put it off.
 /sbin/chkconfig --level 345 afs off
fi
#if [ -x /usr/sbin/chstk ]; then
# /usr/sbin/chstk -e /sbin/insmod
#fi

%post client
if [ ! -d /afs ]; then
	mkdir /afs
	chown root.root /afs
	chmod 0755 /afs
fi

false && {
echo
echo The AFS cache is configured for 100 MB. Edit the 
echo /usr/vice/etc/cacheinfo file to change this before
echo running AFS for the first time. You should also
echo set your home cell in /usr/vice/etc/ThisCell.
echo
echo Also, you may want to edit /etc/pam.d/login and 
echo possibly others there to get an AFS token on login.
echo Put the line:
echo 
echo    auth	   sufficient   /lib/security/pam_afs.so try_first_pass ignore_root
echo
echo before the one for pwdb.
echo
}
true

%post server
if [ -f /etc/sysconfig/afs ] ; then
	srv=`grep ^AFS_SERVER /etc/sysconfig/afs | sed 's/^AFS_SERVER[\s]*=[\s]*//'`
	if [ "x$srv" = "xon" ] ; then
		exit 0
	fi
fi

false && {
echo
echo Be sure to edit /etc/sysconfig/afs and turn AFS_SERVER on
echo
}

%preun
if [ $1 = 0 ] ; then
        %{initdir}/afs stop
        chkconfig --del afs
	[ -d /afs ] && rmdir /afs
fi

%endif
#build_userspace

%if %{build_modules}

%if %{mod_up}

%post -n kernel-module-openafs-%{_kernel}

depmod -ae %{_kernel} >/dev/null 2>&1 || :

%endif

%if %{mod_smp}

%post -n kernel-module-openafs-%{_kernel}smp

depmod -ae %{_kernel}smp >/dev/null 2>&1 || :

%endif

%if %{mod_bigmem}

%post -n kernel-module-openafs-%{_kernel}bigmem

depmod -ae %{_kernel}bigmem >/dev/null 2>&1 || :

%endif

%if %{mod_hugemem}

%post -n kernel-module-openafs-%{_kernel}hugemem

depmod -ae %{_kernel}hugemem >/dev/null 2>&1 || :

%endif

%if %{mod_largesmp}

%post -n kernel-module-openafs-%{_kernel}largesmp

depmod -ae %{_kernel}largesmp >/dev/null 2>&1 || :

%endif

%if %{mod_xenU}

%post -n kernel-module-openafs-%{_kernel}xenU

depmod -ae %{_kernel}xenU >/dev/null 2>&1 || :

%endif

%if %{mod_xen}

%post -n kernel-module-openafs-%{_kernel}xen

depmod -ae %{_kernel}xen >/dev/null 2>&1 || :

%endif

%if %{mod_PAE}

%post -n kernel-module-openafs-%{_kernel}PAE

depmod -ae %{_kernel}PAE >/dev/null 2>&1 || :

%endif

%if %{mod_debug}

%post -n kernel-module-openafs-%{_kernel}debug

depmod -ae %{_kernel}debug >/dev/null 2>&1 || :

%endif

%if %{mod_up}

%postun -n kernel-module-openafs-%{_kernel}

depmod -ae %{_kernel} >/dev/null 2>&1 || :

%endif

%if %{mod_smp}

%postun -n kernel-module-openafs-%{_kernel}smp

depmod -ae %{_kernel}smp >/dev/null 2>&1 || :

%endif

%if %{mod_bigmem}

%postun -n kernel-module-openafs-%{_kernel}bigmem

depmod -ae %{_kernel}bigmem >/dev/null 2>&1 || :

%endif

%if %{mod_hugemem}

%postun -n kernel-module-openafs-%{_kernel}hugemem

depmod -ae %{_kernel}hugemem >/dev/null 2>&1 || :


%endif

%if %{mod_largesmp}

%postun -n kernel-module-openafs-%{_kernel}largesmp

depmod -ae %{_kernel}largesmp >/dev/null 2>&1 || :


%endif

%if %{mod_xenU}

%postun -n kernel-module-openafs-%{_kernel}xenU

depmod -ae %{_kernel}xenU >/dev/null 2>&1 || :


%endif

%if %{mod_xen}

%postun -n kernel-module-openafs-%{_kernel}xen

depmod -ae %{_kernel}xen >/dev/null 2>&1 || :


%endif

%if %{mod_PAE}

%postun -n kernel-module-openafs-%{_kernel}PAE

depmod -ae %{_kernel}PAE >/dev/null 2>&1 || :


%endif

%if %{mod_debug}

%postun -n kernel-module-openafs-%{_kernel}debug

depmod -ae %{_kernel}debug >/dev/null 2>&1 || :


%endif


%endif
#build_modules

###############################################################################
###
### file lists
###
###############################################################################
%if %{build_userspace}
## %defattr(0555,root,root) #this does not work, need to specify attrib within file list
%files -f openafs-file-list
%defattr(-,root,root)
%config(noreplace) /etc/sysconfig/afs
%doc %{_docdir}/openafs-%{afsvers}
%{initdir}/afs

%files client
%defattr(-,root,root)
%dir %{_prefix}/vice
%dir %{_prefix}/vice/cache
%dir %{_prefix}/vice/etc
%config %{_prefix}/vice/etc/CellServDB
%config(noreplace) %{_prefix}/vice/etc/SuidCells
%config(noreplace) %{_prefix}/vice/etc/ThisCell
%config(noreplace) %{_prefix}/vice/etc/cacheinfo
%{_prefix}/vice/etc/C
%{_prefix}/vice/etc/C/afszcm.cat
%{pamdir}/pam_afs.krb.so.1
%{pamdir}/pam_afs.krb.so
%{pamdir}/pam_afs.so.1
%{pamdir}/pam_afs.so
%defattr(0555,root,root)
%{_bindir}/cmdebug
%{_bindir}/up
%{_sbindir}/kdump
%{_prefix}/vice/etc/afsd
%{_prefix}/vice/etc/killafs

%files server
%defattr(-,root,root)
%dir %{_prefix}/afs
%dir %{_prefix}/afs/bin
%dir %{_prefix}/afs/logs
%defattr(0555,root,root)
%{_prefix}/afs/bin/bosserver
%{_prefix}/afs/bin/buserver
%{_prefix}/afs/bin/fileserver
# Should we support KAServer?
%{_prefix}/afs/bin/kaserver
%{_prefix}/afs/bin/kpwvalid
%{_prefix}/afs/bin/pt_util
%{_prefix}/afs/bin/ptserver
%{_prefix}/afs/bin/salvager
%{_prefix}/afs/bin/upclient
%{_prefix}/afs/bin/upserver
%{_prefix}/afs/bin/vlserver
%{_prefix}/afs/bin/volinfo
%{_prefix}/afs/bin/volserver
%{_sbindir}/prdb_check
%{_sbindir}/vldb_check
%{_sbindir}/vldb_convert

%files devel
%defattr(-,root,root)
%attr(0555,root,root) %{_bindir}/rxgen
%{_includedir}/afs
%{_includedir}/des.h
%{_includedir}/des_conf.h
%{_includedir}/des_odd.h
%{_includedir}/lock.h
%{_includedir}/lwp.h
%{_includedir}/mit-cpyright.h
%{_includedir}/potpourri.h
%{_includedir}/preempt.h
%{_includedir}/rx
%{_includedir}/timer.h
%{_includedir}/ubik.h
%{_includedir}/ubik_int.h
%{_libdir}/afs
%{_libdir}/libafsauthent.a
%{_libdir}/libafsrpc.a
%{_libdir}/libdes.a
%{_libdir}/liblwp.a
%{_libdir}/librx.a
%{_libdir}/librxkad.a
%{_libdir}/librxstat.a
%{_libdir}/libubik.a

%files kernel-source
%defattr(-,root,root)
%{_prefix}/src/openafs-kernel-%{afsvers}/LICENSE.IBM
%{_prefix}/src/openafs-kernel-%{afsvers}/LICENSE.Sun
%{_prefix}/src/openafs-kernel-%{afsvers}/README
%{_prefix}/src/openafs-kernel-%{afsvers}/src

%files compat
%defattr(-,root,root)
%{_prefix}/afsws

%files kpasswd
%defattr(-,root,root)
%{_bindir}/kapasswd
%{_bindir}/kpasswd.openafs
%{_bindir}/kpwvalid

%if %{krb5support}
%files krb5
%defattr(-,root,root)
%{_bindir}/aklog
####%{_sbindir}/asetkey
%endif

%endif

%if %{build_modules}

%if %{mod_up}

%files -n kernel-module-openafs-%{_kernel}
%defattr(-,root,root)
%{kxmoddir}/kernel/fs/openafs/openafs%{kobj}
%if !%{no_kdump}
%attr(0555,root,root) %{_sbindir}/kdump-%{_kernel}
%endif

#...mod_up
%endif

%if %{mod_smp}

%files -n kernel-module-openafs-%{_kernel}smp
%defattr(-,root,root)
%{kxmoddir}smp/kernel/fs/openafs/openafs%{kobj}
%if !%{no_kdump}
%attr(0555,root,root) %{_sbindir}/kdump-%{_kernel}smp
%endif

#...mod_smp
%endif

%if %{mod_bigmem}

%files -n kernel-module-openafs-%{_kernel}bigmem
%defattr(-,root,root)
%{kxmoddir}bigmem/kernel/fs/openafs/openafs%{kobj}
%if !%{no_kdump}
%attr(0555,root,root) %{_sbindir}/kdump-%{_kernel}
%endif

#...mod_bigmem
%endif

%if %{mod_hugemem}

%files -n kernel-module-openafs-%{_kernel}hugemem
%defattr(-,root,root)
%{kxmoddir}hugemem/kernel/fs/openafs/openafs%{kobj}
%if !%{no_kdump}
%attr(0555,root,root) %{_sbindir}/kdump-%{_kernel}
%endif

#...mod_hugemem
%endif

%if %{mod_largesmp}

%files -n kernel-module-openafs-%{_kernel}largesmp
%defattr(-,root,root)
%{kxmoddir}largesmp/kernel/fs/openafs/openafs%{kobj}
%if !%{no_kdump}
%attr(0555,root,root) %{_sbindir}/kdump-%{_kernel}largesmp
%endif

#...mod_largesmp
%endif

%if %{mod_xenU}

%files -n kernel-module-openafs-%{_kernel}xenU
%defattr(-,root,root)
%{kxmoddir}xenU/kernel/fs/openafs/openafs%{kobj}
%if !%{no_kdump}
%attr(0555,root,root) %{_sbindir}/kdump-%{_kernel}xenU
%endif

#...mod_xenU
%endif

%if %{mod_xen}

%files -n kernel-module-openafs-%{_kernel}xen
%defattr(-,root,root)
%{kxmoddir}xen/kernel/fs/openafs/openafs%{kobj}
%if !%{no_kdump}
%attr(0555,root,root) %{_sbindir}/kdump-%{_kernel}xen
%endif

#...mod_xen
%endif

%if %{mod_PAE}

%files -n kernel-module-openafs-%{_kernel}PAE
%defattr(-,root,root)
%{kxmoddir}PAE/kernel/fs/openafs/openafs%{kobj}
%if !%{no_kdump}
%attr(0555,root,root) %{_sbindir}/kdump-%{_kernel}PAE
%endif

#...mod_PAE
%endif

%if %{mod_debug}

%files -n kernel-module-openafs-%{_kernel}debug
%defattr(-,root,root)
%{kxmoddir}xen/kernel/fs/openafs/openafs%{kobj}
%if !%{no_kdump}
%attr(0555,root,root) %{_sbindir}/kdump-%{_kernel}debug
%endif

#...mod_debug
%endif

#...build_modules
%endif



###############################################################################
###
### openafs.spec change log
###
###############################################################################
%changelog
* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.11-5.cern 17.03.2010
- p_pag_noquota: pag-keyring out-of-quota for root, with p_FlushDCache

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.11-4.cern 16.03.2010
- p_pag_noquota: pag-keyring out-of-quota for root, without p_FlushDCache

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.11-3.cern 17.02.2010
- OpenAFS-revised p_lockless_validate

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.11-2.cern 09.02.2010
- p_FlushDCache: flush dcache entries after truncate, instead of synchronous truncate

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.11-1.cern 26.1.2010
- incomplete DV update in afs_segments.c leads to pages zeroed out

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.8-9.cern 28.07.2009
- throttle only after > 4 pags/sec

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.8-8.cern 18.05.2009
- fix fd3 problem

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.8-4.cern 23.04.2009
- avoid-buffer-overflow-on-rx-fixed-size-array-return-20090402

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.8-1.cern 26.02.2009
- use_VFSlayer rework, fix Prefetch

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.8-0.cern 19.12.2008
- 

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.7-4.cern 18.12.2008
- VBUSY -> vosmove -> ETIMEDOUT problem improved p_retryServerDown

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.7-3.cern 05.11.2008
- "nmn" problem: AFS_TRY_GLOCK

* Mon Jan 18 2038 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 1.4.6-4.cern 18.8.2008
- fixed SLC5/RHEL5 build

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.6-3.cern 25.4.2008
- recover from transient connection timeouts, rechecking volume

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.6-2.cern 27.3.2008
- a marginally finer symlink/moint point distinction

* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 1.4.6-1.cern 14.1.2008
- man pages added

* Mon Jan 18 2008 rtb <rtb@mail.cern.ch> 1.cern 29.4.2005
- chaotic revamp

* Sat Jun 19 2004  Troy Dawson <dawson@fnal.gov> 15.4.SL
- Made more changes to startup script. Does sanity checks of ThisCell

* Fri Jun 18 2004  Troy Dawson <dawson@fnal.gov> 15.3.SL
- Made change to /etc/init.d/afs startup script

* Sun May 30 2004 Jaroslaw.Polok@cern.ch
- rebuilt for Scientific Linux without site-specific setup
- kerberos 5 enabled in build
* Fri Apr 16 2004  Jaroslaw.Polok@cern.ch
- changed packaging of modules again: to followup Fedora Core
  (draft) rules and allow yum/apt/up2date to handle these

* Tue Apr 06 2004  Jaroslaw.Polok@cern.ch
- changed packaging of modules

* Sun Feb 22 2004  Jaroslaw.Polok@cern.ch
- Rebuilt for CERN E. Linux (ix86/ia64/x86_64)

* Thu Sep  4 2003  David Howells <dhowells@redhat.com>> 1.2.10-4
- don't use rpm from within spec file as this can cause problems

* Wed Sep  3 2003  David Howells <dhowells@redhat.com> 1.2.10-4
- added ia64 to the ExclusiveArch list

* Fri Aug 29 2003  <David Howells <dhowells@redhat.com>> 1.2.10-3
- get rid of a %%else that causes problems with rpm-4.0.4

* Fri Aug 22 2003  David Howells <dhowells@redhat.com> 1.2.10-3
- added rpmbuild cmdline defines to control which bits to build

* Wed Aug 20 2003  Nalin Dahyabhai <nalin@redhat.com>
- obey CFLAGS set at configure-time on i386/x86_64 linux
- openafs-krb5: look in $krb5_prefix/lib64 for Kerberos libraries if they are
  not found in $krb5_prefix/lib
- build the modules for PAM on x86_64
- when checking for res_search, try to link with it instead of checking for it
  in libraries, in case it's a macro or redefined by a macro
- use %%{ix86} instead of %%{all_x86} where appropriate
- install AFS libraries into %%{_libdir} instead of %%{_prefix}/lib

* Fri Aug 15 2003  <David Howells <dhowells@redhat.com>> 1.2.10-3
- permit the kernel-to-build-against to be selected by cmdline argument to
  rpmbuild if preferred

* Thu Aug 14 2003  Nalin Dahyabhai <nalin@redhat.com>
- fix compilation of openafs-krb5 bits against krb5 1.3

* Mon Aug 11 2003  <David Howells <dhowells@redhat.com>> 1.2.10-2
- got rid of all rpmlint errors
- delete certain tags (Packager/Vendor/Distribution)

* Fri Aug  8 2003  <David Howells <dhowells@redhat.com>> 1.2.10-1
- Adapted OpenAFS version 1.2.10 to compile in beehive

